# Fill in your config below
EMAIL = 'nobody@nowhere.com'
PASSWORD = 'secret'
TWINE_ID = 'blahblah'

USER_AGENT = 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)' # fake a user agent, some websites (like google) don't like automated exploration
import os.path
import urllib
import urllib2
import json
import cookielib
from StringIO import StringIO

# Convert Fahrenheit to Celsius
# Celsius = 5/9 (Fahrenheit - 32)
def FtoC(value):
    return round(5.0/9.0 * ( value - 32), 2)

# set some global variables
urlopen = urllib2.urlopen
Request = urllib2.Request

# setup cookie handling
cj = cookielib.LWPCookieJar()
opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
urllib2.install_opener(opener)

# prepare to login
theurl = 'https://twine.supermechanical.com/login'
txdata = urllib.urlencode({'email': EMAIL, 'password': PASSWORD})
txheaders =  {'User-agent' : USER_AGENT}

# do the login
try:
    req = Request(theurl, txdata, txheaders)
    handle = urlopen(req)
except IOError, e:
    print 'We failed to open "%s".' % theurl
    if hasattr(e, 'code'):
        print 'We failed with error code - %s.' % e.code
	exit()

# prepare to get the data
theurl = 'https://twine.supermechanical.com/rt/' + TWINE_ID + '?cached=1'
txdata = None

# get the data
result = None
try:
    req = Request(theurl, txdata, txheaders)
    cj.add_cookie_header(req) # add the received cookie(s) to this request
    handle = urlopen(req)
except IOError, e:
    print 'We failed to open "%s".' % theurl
    if hasattr(e, 'code'):
        print 'We failed with error code - %s.' % e.code
    exit()
else:
    io = StringIO(handle.read())
    result = json.load(io)

# handle the result
if result != None:
    for index, value in result['values']:
        if index == '0000d47c6a53066a01':
            print 'Temperature:', FtoC(value/100), unichr(176) + 'C'
        if index == '0000d47c6a53066a03':
            print 'Orientation:', value
        if index == '0000d47c6a53066a05':
            print 'Voltage:', round(value/1000000.0, 2)
        if index == '01a5474016000049':
            if value == 0:
                print 'Swith: open'
            if value == 1:
                print 'Swith: closed'
        if index == '01046a8a150000f0':
            if value == 0:
                print 'Moisture: dry'
            if value == 1:
                print 'Moisture: wet'
        if index == '018d0e4016000044':
            print 'Breakout:', value
    print 'Signal strength', result['rssi'] # is this correct, rssi = Received Signal Strength Indication?